/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package artificial.intelligence;

/**
 *
 * @author Xavier
 */
public class ReadData {
    
    public static Hospital readInputFile(String file) {
        ReadFile read = new ReadFile(file);
        read.Lire();
        Hospital hospital = new Hospital();
        int i = 0;
        for(i = 0; i<read.getLigne().length; i++) {
            String ligne = read.getLigne(i);
            if(ligne.contains("SPECIALISMS:")) {
                break;
            }
        }
        i++;
        while(i<read.getLigne().length) {
            
            if("".equals(read.getLigne(i))) {
                break;
            }
            Specialisms s = readSpacialism(read.getLigne(i));
            if(s != null) {
                hospital.getSpecialism().add(s);
            }
            i++;
        }
        while(i<read.getLigne().length) {
            String ligne = read.getLigne(i);
            if(ligne.contains("DEPARTMENTS:")) {
                break;
            }
            i++;
        }
        i++;
        while(i<read.getLigne().length) {
            
            if("".equals(read.getLigne(i))) {
                break;
            }
            Departments d = readDepartments(read.getLigne(i), hospital);
            if(d != null) {
                hospital.getDepartment().add(d);
            }
            i++;
        }
        
        while(i<read.getLigne().length) {
            String ligne = read.getLigne(i);
            if(ligne.contains("ROOMPROPERTIES:")) {
                break;
            }
            i++;
        }
        i++;
        while(i<read.getLigne().length) {
            
            if("".equals(read.getLigne(i))) {
                break;
            }
            RoomProperties r = readRoomProp(read.getLigne(i), hospital);
            if(r != null) {
                hospital.getRoomProp().add(r);
            }
            i++;
        }
        
        while(i<read.getLigne().length) {
            String ligne = read.getLigne(i);
            if(ligne.contains("ROOMS:")) {
                break;
            }
            i++;
        }
        i++;
        while(i<read.getLigne().length) {
            
            if("".equals(read.getLigne(i))) {
                break;
            }
            Room r = readRoom(read.getLigne(i), hospital);
            if(r != null) {
                hospital.getRooms().add(r);
            }
            i++;
        }
        
        while(i<read.getLigne().length) {
            String ligne = read.getLigne(i);
            if(ligne.contains("BEDS:")) {
                break;
            }
            i++;
        }
        i++;
        while(i<read.getLigne().length) {
            
            if("".equals(read.getLigne(i))) {
                break;
            }
            addBed(read.getLigne(i), hospital);

            i++;
        }
        
        while(i<read.getLigne().length) {
            String ligne = read.getLigne(i);
            if(ligne.contains("PATIENTS:")) {
                break;
            }
            i++;
        }
        i++;
        while(i<read.getLigne().length) {
            
            if("".equals(read.getLigne(i))) {
                break;
            }
            Patient p = readPatient(read.getLigne(i), hospital);
            if(p != null) {
                hospital.getPatient().add(p);
            }
            i++;
        }
        
        return hospital;
    } 
    
    
    
    public static void readOutputFile(String file, Hospital hospital) {
        ReadFile read = new ReadFile(file);
        read.Lire();
        for(int i = 0; i<read.getLigne().length; i++) {
            String ligne = read.getLigne(i);
            if("".equals(ligne)) {
                break;
            }
            String[] elements = ligne.split(" ");
            if(elements.length>1) {
                int idPatient = toInt(elements[0]);
                Patient p = hospital.getPatient(idPatient);
                if(p!= null) {
                    for(int j = 1; j<elements.length; j++) {
                        if(!elements[j].equals("")) {
                            int idBed = toInt(elements[j]);
                            Beds b = hospital.getBeds(idBed);
                            Occupied occ = new Occupied(p, p.getFirstDay()+j-1);
                            b.getOccupied().add(occ);
                        }
                    }
                }
            }
            
        }
    }

    public static int toInt(String num) {
        String numS = num.replaceAll("[^0-9]","");
        
        int numI = 0;
        if(!"".equals(numS)) {
            numI = Integer.parseInt(numS);
        }
        
        return numI;
    }
    
    
    private static Specialisms readSpacialism(String ligne) {
        if(ligne == null || "".equals(ligne)) {
            return null;
        }
        String[] spec = ligne.split(" ");
        if(spec.length <2) {
            return null;
        }

        int id = toInt(spec[0]);

        
        
        return new Specialisms(id, spec[1]);
        
    }

    private static Departments readDepartments(String ligne, Hospital hospital) {
        if(ligne == null || "".equals(ligne)) {
            return null;
        }
        String[] lig = ligne.split(" ");
        if(lig.length <5) {
            return null;
        }
        int id = toInt(lig[0]);
        String name = lig[1];
        int minAge = toInt(lig[2]);
        int maxAge = toInt(lig[3]);
        
        Departments d = new Departments(id, name, minAge, maxAge); 
        
        for(int i = 5; i<lig.length-1;i = i+2) {
            int priority = toInt(lig[i]);
            Specialisms s = hospital.getSpecialism(toInt(lig[i+1]));
            
            if(s!= null) {
                d.getPrioritySpec().add(priority);
                d.getSpecialism().add(s);
            }
            
        }
        
        return d;
    }

    private static RoomProperties readRoomProp(String ligne, Hospital hospital) {
        if(ligne == null || "".equals(ligne)) {
            return null;
        }
        String[] spec = ligne.split(" ");
        if(spec.length <2) {
            return null;
        }

        int id = toInt(spec[0]);
        
        return new RoomProperties(id, spec[1]);
    }

    private static Room readRoom(String ligne, Hospital hospital) {
        if(ligne == null || "".equals(ligne)) {
            return null;
        }
        String[] lig = ligne.split(" ");
        if(lig.length <5) {
            return null;
        }
        int id = toInt(lig[0]);
        int roomNo = toInt(lig[1]);
        Departments de = hospital.getDepartment(toInt(lig[5]));
        char gender = lig[7].charAt(0);
        Room room = new Room(id, roomNo, gender);
        room.setDepartment(de);
        int i = 9;
        for(i = 9; i<lig.length-1;i = i+2) {
            if("|".equals(lig[i])) {
                i++;
                break;
            }
            int priority = toInt(lig[i]);
            Specialisms s = hospital.getSpecialism(toInt(lig[i+1]));
            
            if(s!= null) {
                room.getPrioritySpec().add(priority);
                room.getSpecialisms().add(s);
            }
        }
        int prop = 0;
        while(i<lig.length) {
            int isOne = toInt(lig[i]);
            if(isOne == 1 && prop < hospital.getRoomProp().size()) {
                RoomProperties rP = hospital.getRoomProp().get(prop);
                room.getProperties().add(rP);
            }
            prop++;
            i++;
        }
        
        
        return room;
    }

    private static void addBed(String ligne, Hospital hospital) {
        if(ligne == null || "".equals(ligne)) {
            return;
        }
        String[] spec = ligne.split(" ");
        if(spec.length <2) {
            return;
        }

        int id = toInt(spec[0]);
        Room room = hospital.getRoom(toInt(spec[1]));
        
        if(room != null) {
            Beds b = new Beds(id);
            room.getBeds().add(b);
        }
        
    }

    private static Patient readPatient(String ligne, Hospital hospital) {
        if(ligne == null || "".equals(ligne)) {
            return null;
        }
        String[] lig = ligne.split(" ");
        if(lig.length <5) {
            return null;
        }
        int id = toInt(lig[0]);
        String name = lig[1];
        int age = toInt(lig[2]);
        char gender = lig[3].charAt(0);
        int firstDay = toInt(lig[5]);
        int lastDay = toInt(lig[6]);
        Patient p = new Patient(id, name, age, gender, firstDay, lastDay);
        int nbrSpecialim = toInt(lig[8]);
        
        for(int i = 9; i<9+nbrSpecialim*2;i = i+2) {
            Specialisms s = hospital.getSpecialism(toInt(lig[i]));
            int days = toInt(lig[i+1]);
            if(s!= null) {
                Stay stay = new Stay(s, days);
                p.getStays().add(stay);
            }   
        }
        int roomPreference = toInt(lig[9+nbrSpecialim*2+1]);
        p.setRoomPreference(roomPreference);
        
        return p;
    }
    
    
    
}
